Subject: Fw: [Bug 204399] New: error in handling vlan tag by raw ethernet socket

From: Stephen Hemminger <[email-masked]>
Date: Thu, 1 Aug 2019 07:51:47 -0700

Begin forwarded message:

Date: Thu, 01 Aug 2019 06:37:39 +0000
From: [email-masked]
To: [email-masked]
Subject: [Bug 204399] New: error in handling vlan tag by raw ethernet socket

https://bugzilla.kernel.org/show_bug.cgi?id=204399

            Bug ID: 204399
           Summary: error in handling vlan tag by raw ethernet socket
           Product: Networking
           Version: 2.5
    Kernel Version: 5.0.0-21-generic #22-Ubuntu x86_64
          Hardware: All
                OS: Linux
              Tree: Mainline
            Status: NEW
          Severity: high
          Priority: P1
         Component: IPV4
          Assignee: [email-masked]
          Reporter: [email-masked]
        Regression: No

Created attachment 284067
  --> https://bugzilla.kernel.org/attachment.cgi?id=284067&action=edit  
set/unset the variable "stripping_vlan_tag" to reproduce the issue

I am using raw ethernet socket and sending/receiving network traffic.

problem I am seeing is if read socket is opened before starting sending the
vlan traffic, read socket is able to capture packets along with vlan tag. but
if I open the read socket before starting sending the packets, vlan tag is
being stripped and only those four bytes are missing from the packet. Rest of
the packet is intact.

Please refer to the small code snippet which consistently produces the bug.

set/unset the variable "stripping_vlan_tag" to reproduce the issue.

is this a bug in the kernel or any problem with my coding ?

I am working on a project where I will be opening all the required sockets at
once and will be using as and when required. In that case, I am not able to
capture vlan tags which is blocking me. However, tcpdump is capture along with
vlan tag.

please be noted that, both the cards are in same system and are connected just
back to back using a cat5 cable. eth0 is built-in card and eth1 is usb based
external network card.

Is there a way to get rid of this issue ?

Best Regards,
Lokesh.

-- 
You are receiving this mail because:
You are the assignee for the bug.